# Changelog

## [Unreleased]

### Diagram

#### Bug Fixes

- `#F-182592,#FB-45000` - scrollbar flickering issue in mac on zooming the diagram has been fixed now.
- `#I44765` - Now, Event "Start" state triggers for single time in rotate and resize action.
- `#I44765` - Now, Duplicate nodes and connectors are created after reset for layout type 'None' has been fixed now.

## 22.1.38 (2023-07-11)

### Diagram

#### Bug Fixes

- `#I44765` - Now, child nodes are properly rendered after deleting swimlane and performing undo action.
- `#I473032`- Now, the orthogonal connector routing works properly when we drag connector segment.

## 22.1.36 (2023-06-28)

### Diagram

#### Bug Fixes

- `#I468711` - Now, opacity 0 get working for the image node.
- `#I182694` - Now, UML multiplicity type ManyToMany get working for annotation label.
- `#I467016` - Improved rendering performance for layouts with large number of nodes.
- `#I469741` - Fixed undo redo issue with group nodes.
- `#I471066` - Now, dragging group node from palette to diagram adds unselectable element when leaving the diagram has been fixed.
- `#I448032` - Fixed grid lines appearing black in Safari browser.
- `#I466480` - Improved performance while nudging large number of nodes.

## 22.1.34 (2023-06-21)

### Diagram

#### New Features

- `#F152758` - Added tooltip support for ports.
- `#I420267` - Added tooltip support for symbols in the symbol palette.
- `#I32153` - Provided vertical orientation for mind maps.
- `#I392082` - Added functionality to load diagrams from EJ1 to EJ2.
- `#I327078` - Provided support to customize the expand and collapse icons.

## 21.2.9 (2023-06-06)

### Diagram

#### Bug Fixes

- `#I463138` - Now, Scroll bar is updated properly without flickering while scrolling the diagram using touchpad.
- `#I464508` - The DOM Exception will no longer thrown while adding group node dynamically with multiple layers.

## 21.2.8 (2023-05-30)

### Diagram

#### Bug Fixes

- `#I461020` - The undefined Exception will No longer thrown while dragging Swimlane after performing undo/redo on swimlane child nodes.
- `#I462780` - Now, Nodes are updated properly while zoom out diagram in canvas mode.

## 21.2.6 (2023-05-23)

### Diagram

#### Bug Fixes

- `#I464229` -  Now, Complex hierarchical tree layout is working fine while injecting line distribution.

## 21.2.5 (2023-05-16)

### Diagram

#### Bug Fixes

- `#I456104` -  Now, swimlane child nodes are selectable after save and load.

## 21.2.4 (2023-05-09)

### Diagram

#### Bug Fixes

- `#I456288` - Now, scroller updated properly when we move nodes outside viewport.
- `#I458205` - Now, bezier connector annotation alignment is working properly.
- `#I456037` - Now, while hovering the port with single select and ZoomPan constraints drawing tool enabled.

## 21.2.3 (2023-05-03)

### Diagram

#### Bug Fixes

- `#I451762` - Now, the flip mode port is working for all nodes.
- `#I449574` - Now, the performance of the diagram is improved while rendering large number of nodes and connectors.
- `#I454253` - Now, fill color for bpmn transaction subprocess is applied properly.
- `#I455551` - Now, history change event does not get triggered while clicking swimlane header for second time.

## 21.1.39 (2023-04-11)

### Diagram

#### Bug Fixes

- `#I448343` - Now, position change event completed state is fired properly.
- `#I446954` - Now, the segment does not get dragged when there is no thumb in it.

## 21.1.37 (2023-03-29)

### Diagram

#### Bug Fixes

- `#I41762` - Now, Different point property for bezier connector is working properly.
- `#I41808` - Now, Text description for HTML node is rendered properly.
- `#I41908` - Now, Perfomance of dragging group nodes is improved.
- `#I41974` - Now, While hovering ports and dragging the multiselected items working properly.
- `#I443748` - Now, changing the styles dynamically, its working properly.
- `#I445506` - Now, you can resize the bezier control thumb when we increase the handleSize also.
- `#I444124` - Now, set the same id for the node and annotation in two different diagrams, the first diagram node annotation is visible properly.
- `#I447256` - Node renders properly on changing the shape dynamically.

## 21.1.35 (2023-03-23)

### Diagram

#### Bug Fixes

- `#F180478` - Now, the performance of diagram while enabling virtualization is improved.
- `#F180478` - Now, Overview is updated properly while enabling virtualization.
- `#I422299` - Now, swimlane child nodes is selectable after save and load.
- `#I437322` - Now, drag the connector end thumb is working, while we increase handleSize value.
- `#I436649` - Now, connector segment does not get split into multiple segment for top to bottom approach.
- `#I440967` - Now, Free hand connector segment collection restored after save and load the diagram.
- `#I441075` - Now, position change event does not get triggered while click on the swimlane header.

## 20.4.50 (2023-02-14)

### Diagram

#### Bug Fixes

- `#I432667` - Now, overview updated properly while doing interactions after zoom out.
- `#I433980` - Now, the nodes selections are proper for nodes with large annotations.

## 20.4.48 (2023-02-01)

### Diagram

#### Bug Fixes

- `#I427930` - The issue "BringIntoView API brings the object in large bounds into the screen viewport" has been fixed.
- `#I428356` - Now, parent node position in radial tree layout is updated properly, while adding nodes dynamically.

## 20.4.42 (2023-01-04)

### Diagram

#### Bug Fixes

- `#I426113` - Now, bezier control points dragging is restricted when we hide control points.
- `#I425406` - Now, the bezier segment points are not static when we move connector source or target node.
- `#I422049` - Now, calling doLayout after injecting line routing module working properly.
- `#I421754` - The issue on tooltip relative mode mouse is now working properly.
- `#I423978` - Now, HTML nodes gets update properly in the overview while auto scroll the diagram.

## 20.4.40 (2022-12-28)

### Diagram

#### Bug Fixes

- `#I421800` - Now, bezier connector rendered properly while save and load the diagram.
- `#I417240` - Now, dropping bpmn text annotation node inside the swimlane is working properly.

## 20.4.38 (2022-12-22)

### Diagram

#### New Feature

- `#I409589` - Support to override the mouseWheel event has been added.

#### Bug Fixes

- `I421148` - Now, connector segment does not get split into multiple segment while hover on node.
- `#I420202` - The issue on annotation interaction has been resolved.

## 20.3.60 (2022-12-06)

### Diagram

#### Bug Fixes

- `#FB38642`  - Now, the arg cancel property for sourcePoint and targetPoint change is working properly.
- `#I419333` - Now, dragging a object outside the diagram canvas from symbol palette is updated properly.
- `#I397852` - Now, defining connector without source or target id while injecting Line Routing is rendered properly.
- `#I42108` - The issue on hovering the node ports has been resolved.

## 20.3.58 (2022-11-22)

### Diagram

#### Bug Fixes

- `#I418455` - Now, the resize handle has been rendered properly while set node pivot as 0,0.
- `#I418026` - Now, the annotation for the swimlane child node is updated properly after dragging it outside the swimlane.

## 20.3.57 (2022-11-15)

### Diagram

#### Bug Fixes

- `#I412223` - Now, the connector position is updated properly after resizing overview panel.
- `#I405669` - Now, adding BPMN Text annotation node inside swimlane at runtime is working properly.
- `#I412144` - Now, the segment thumb do not gets rendered while render orthogonal connector as a straight line.
- `#I412144` - Provided the support for orthogonal segment overlap with the source and target node.

## 20.3.50 (2022-10-18)

### Diagram

#### Bug Fixes

- `#I409105` - Now, click event gets triggered properly when click at scrollbar position.
- `#I410274` - Now, adding lane to the existing vertical swimlane is working properly.

## 20.3.49 (2022-10-11)

### Diagram

#### Bug Fixes

- `#I405054` - Provided the custom context menu support for the swimlane phase.
- `#I405669` - Now, BPMN text annotation node gets dragged properly while drag the swimlane.
- `#I397116` - Now, the bezier annotation horizontal and vertical alignment is working properly.
- `#I410634` - The null exception will no longer thrown while changing the overview id.

## 20.3.48 (2022-10-05)

### Diagram

#### Bug Fixes

- `#I401143` - Now, HTML element gets rendered properly while drag and drop from one lane to other lane.
- `#I393859` - Now, the nodes overlapping in linear arrangement of complex-hierarchical tree is resolved.

## 20.3.47 (2022-09-29)

### Diagram

#### Bug Fixes

- `#I387297` - Now, the Expand & Collapse work properly for layout.
- `#I389174` - The undefined exception will no longer thrown while drag and drop the node from treeview to diagram.
- `#I384522` - Now, connector gets rendered properly in the complex hierarchical tree layout.
- `FB36050` - Now, oldValue & newValue argument of property change event updated properly while change order for nodes.
- `#I383401` - BPMN task type symbols are updated as per BPMN 2.0 standard.
- `#FB35907` - Localization support for symbol palette search box placeholder has been added.
- `#I388692` - Now connectors are properly connected to the node after save and load.
- `#I384554` - Now scroll settings offset are updated properly dynamically.
- `#I397678` - Now, the connector is dropped properly inside the swimlane.
- `#I395331` - The undefined exception will no longer thrown while draw a SVG node.
- `#I397116` - Now, Bezier connector annotation rendered at the proper position.
- `#I396868` - Now bezier connector rendered properly while drag and drop from palette.
- `#I397852` - Now, layers undefined exception will no longer thrown while save and load.
- `#I399417` - Now, fit to page is working properly when we call it multiple times.

## 20.2.36 (2022-06-30)

### Diagram

#### Bug fixes

- `#I382500` - Now, the BPMN shape is changed properly at runtime.
- `#I382496` - BPMN gateway sub type is working properly while changing it during runtime.
- `#I383411` - Now, fill color is applied properly when changing BPMN event at runtime.

#### New Features

- `#I362749` - Provided option to adjust the distance between the source node and the target node of the orthogonal connection has been added.
- `#I347713` - Support to modify connector segments thumb icon shape and style has been added.
- `#FB31535` - Support for splitting and joining connectors has been added.
- `#I362796` - Support to highlight selected diagram elements on multiple selections has been added
- `#I362829` - Support to limit the connector segments while draw at run time has been added.
- `#I362755` - Support to edit multiple bezier segments with multiple control points has been added.

#### Behaviour changes

- In the Bezier connector, by default, the multiple segments will be created automatically if a user doesn't define segment collections in the application.
- In the Bezier connector, based on segment count, multiple control points will be displayed to control the smoothness of the curve

## 20.1.60 (2022-06-14)

### Diagram

#### Bug Fixes

- `#I381671` - Bpmn task type is working properly while changing from type Send to Receive.
- `#F175332` - Undo is working properly after deleting the node attached with connector.
- `#I376982` - Annotation dragging in connector and node is working properly when we set horizontal Alignment and vertical Alignment.

## 20.1.59 (2022-06-07)

### Diagram

#### Bug Fixes

- `#I378190` - Now, distribute commands will work properly.

## 20.1.57 (2022-05-24)

### Diagram

#### Bug Fixes

- `F173877` - Now, Node template has been rendered properly in layout.

## 20.1.55 (2022-05-12)

### Diagram

#### Bug Fixes

- `#I373763` - Now, old value of SelectionChange event are updated properly.
- `#I373774` - The sourcePointChange and targetPointChange events are triggered while dragging the node.
- `#I375741` - Now, the performance and Memory leak is resolved in the saveDiagram method.
- `#I372151` - Now, bezier connector annotation get exported properly as an image.
- `#I376498` - Now, the diagram zooming behaviour is changed as an old behaviour.

## 20.1.51 (2022-04-26)

### Diagram

#### Bug Fixes

- `#I375103` - Now, Port visibility will work properly on mouse hover in Canvas mode.

## 20.1.48 (2022-04-12)

### Diagram

#### Bug Fixes

- `FB-33350` - Now, Property change event will trigger properly when z-index values are changed.
- `#I372613` - Now, Exporting the diagram as an image will work properly.

## 20.1.47 (2022-04-04)

### Diagram

#### Bug Fixes

- `#32965` - Now, old and new value of property change event values are updated properly while drag the connector target end.
- `F172843` - Bring to front is now working properly for the multiple selection.
- `SF-369300` - Now, Expand and collapse work properly for layouts.
- `SF-370061` - Now, exportDiagram exports image url properly when mode is set to Data.
- `SF-368435` - The exception will no longer thrown while dragging the selected object.
- `SF-362356` - Now, Diagram can be zoomed or scrolled smoothly.

## 19.4.54 (2022-03-01)

### Diagram

#### Bug Fixes

- `F170870` - The undefined exception will no longer thrown while drag and drop the node over another node.
- `SF-364881` - Selection is now work properly for group node on negative axis.
- `SF-366628` - Node annotation is now update properly while edit in the canvas mode.
- `SF-364084` - Now, Lane Header can be simply obtained from selection change event.
- `SF-366851` - Node Linear gradient is now exported properly while export the diagram.

## 19.4.53 (2022-02-22)

### Diagram

#### Bug Fixes

- `SF-360354` - Position change event is now fired properly while drag and drop the node using touch.
- `SF-365716` - Drawing tool now draw connector properly while right click on the diagram.
- `SF-364857` - Now, Command/Meta key will work properly on Mac.

## 19.4.52 (2022-02-15)

### Diagram

#### Bug Fixes

- `SF-361654` - Connector is now rendered properly in the symbol palette while try to render as straight line.
- `SF-360571` - Provide separate tooltip support for the group children node.
- `SF-359118` - Now, the Scroll Bar works properly when Viewport is in Negative coordinates.
- `SF-362880` - Save and load now works properly for Swimlane after undo and redo.

## 19.4.50 (2022-02-08)

### Diagram

#### Bug Fixes

- `SF-360650` - The Undefined exception will no longer be thrown while perform ctrl + shift + mouse click on diagram area.
- `SF-359437` - The Undefined exception will no longer be thrown while ungroup the group node in canvas mode.
- `SF-359860` - Node gradient color is now exported properly while export the diagram in JPG.
- `SF-362805` - Bezier connector text element bounds is now calculated properly while drag the connector.
- `SF-362170` - Annotation editing for the Bezier Connector is now working properly.
- `SF-362805` - Style Property margin is now working properly for the Bezier Connector Annotation.
- `F170870` - Resolved the exception when Flipping SVG Nodes Label.

## 19.4.43 (2022-01-18)

### Diagram

#### Bug Fixes

- `F171509` - The issue "getDiagramContent() is not working properly" has been fixed.

## 19.4.42 (2022-01-11)

### Diagram

#### Bug Fixes

- `SF-359118` - The issue "Scroll Bar is not working properly when Viewport is in Negative coordinates" has been fixed.
- `F171398` - The issue "Exception occurs when save and load the diagram" has been fixed.
- `SF-360354` - The issue "Symbol do not get dropped properly in the chrome android" has been fixed.

## 19.4.41 (2022-01-04)

### Diagram

#### Bug Fixes

- `SF-358407` - The issue "NodeTemplate is not rendered properly in React" has been fixed.
- `SF-358519` - The issue "SendToBack is not working properly when re-adding shapes on diagram" has been fixed.
- `F170870` - The issue "Ports are not flipped while flipping Node to Horizontal or Vertically" has been fixed.
- `F170870` - The issue "Provide support to prevent label flipping while flipping the node horizontally or vertically" has been fixed.

## 19.4.40 (2021-12-28)

### Diagram

#### Bug Fixes

- `F171088` - The issue "Multiple selection tool not working properly" has been fixed.
- `SF-353924` - The issue "Drag and drop element from tree-view to Diagram does not behave correctly" has been fixed.
- `SF-333944` - The issue "Exception raises when perform sendBackward with native node" has been fixed.
- `SF-358147` - The issue "Labels are not updated properly after loading the saved JSON" has been fixed.
- `#30924` - The issue "Horizontal scrolling not working properly with trackpad" has been fixed.
- `#31218` - The issue "Pinch zoom not working properly with trackpad in i-Mac" has been fixed.
- `SF-357916` - The issue "Bezier Connector target decorator is not rendered properly at initial rendering" has been fixed.

## 19.4.38 (2021-12-17)

### Diagram

#### Bug Fixes

- `SF-356262` - The issue "Dragging and Drop node not working properly by enabling page settings" has been fixed.
- `F170399` - The issue "Unable to cast exception occurs when clicking on the expand icon" has been fixed.
- `#I337722` - The issue "Connector Position not Updated Properly when rotating it with segments" has been fixed.
- `#I341943` - The issue "BringIntoView API does not bring the large bounds into the screen viewport" has been fixed.
- `#I342681` - The issue "BPMN Task shape becomes ellipse shape when printing the diagram" has been fixed.
- `#I342979` - The issue "While loading the JSON data with line routing causes exception in Angular" has been fixed.
- `#I345844` - The issue "An exception occurs when perform search in the symbol palette" has been fixed.
- `#F169922` - The issue "Need to provide support to set assistants based on datasource field in organizational chart" has been fixed.
- `#I345570` - The issue "Nodes doesn't gets arranged in zindex order after grouping it" has been fixed.
- `#I346110` - The issue "Text did not display on Connector line after adjusting the Bezier Connector" has been fixed.
- `#I346676` - The issue "Drag and drop item from Tree-View to Diagram doesn't behave correctly" has been fixed.
- `#I347727` - The issue "RemovePalette API not working properly" has been fixed.
- `#I348028` - The issue "SelectionChange newValue is null when deselecting one of multiple selected shapes" has been fixed.

## 19.3.56 (2021-12-02)

### Diagram

#### Bug Fixes

- `#F30109` - The issue "Diagram virtualization does not work with BPMN shapes" has been fixed.
- `#348672` - The issue "Swimlane nodes helper position not updated properly" has been fixed.
- `#F170298` - The issue "Template is not updated properly while render multiple diagram in same page" has been fixed.
- `#347603` - The issue "HTML Nodes are not rendered in Overview" has been fixed.

## 19.3.55 (2021-11-23)

### Diagram

#### Bug Fixes

- `#I346676` - The issue "Drag and drop item from Tree-View to Diagram doesn't behave correctly" has been fixed.
- `#I347727` - The issue "RemovePalette API not working properly" has been fixed.
- `#I348028` - The issue "SelectionChange newValue is null when deselecting one of multiple selected shapes" has been fixed.

## 19.3.53 (2021-11-12)

### Diagram

#### Bug Fixes

- `#I346110` - The issue "Text did not display on Connector line after adjusting the Bezier Connector" has been fixed.

## 19.3.48 (2021-11-02)

### Diagram

#### Bug Fixes

- `#I345844` - The issue "An exception occurs when perform search in the symbol palette" has been fixed.
- `#F169922` - The issue "Need to provide support to set assistants based on datasource field in organizational chart" has been fixed.
- `#I345570` - The issue "Nodes doesn't gets arranged in zindex order after grouping it" has been fixed.

## 19.3.47 (2021-10-26)

### Diagram

#### Bug Fixes

- `#I342681` - The issue "BPMN Task shape becomes square shape when printing the diagram" has been fixed.

## 19.3.46 (2021-10-19)

### Diagram

#### Bug Fixes

- `#I342979` - The issue "While loading the JSON data with line routing causes exception in Angular" has been fixed.

## 19.3.45 (2021-10-12)

### Diagram

#### Bug Fixes

- `#I342681` - The issue "BPMN Task shape becomes ellipse shape when printing the diagram" has been fixed.

## 19.3.44 (2021-10-05)

### Diagram

#### Bug Fixes

- `#I337722` - The issue "Connector Position not Updated Properly when rotating it with segments" has been fixed.
- `#I341943` - The issue "BringIntoView API does not bring the large bounds into the screen viewport" has been fixed.

## 19.3.43 (2021-09-30)

### Diagram

#### Bug Fixes

- `#F166882` - The issue "Accessibility validation error in Measure element Div" has been fixed.
- `#I341447` - The issue "The historyChange event is not triggered while rotate and move the node" has been fixed.
- `#I338448` - The issue "An exception occurs when save and load the diagram with PreventDefaults as true" has been fixed.
- `#I338105` - The issue "The drawing tool draws multiple node while perform right click" has been fixed.
- `#I339621` - The issue "An exception occurs render a image node with alignment as none and scale  as Stretch" has been fixed.
- `#I339619` - The issue "An exception occurs when save and load the swimlane with BPMN children" has been fixed.
- `#I339487` - The issue "The connector drawing object does not snap to near by port" has been fixed.
- `#I342173` - The issue "An exception occurs when clear the diagram using Clear API" has been fixed.
- `#I341524` - The issue "The selection change event returns empty NewValue argument while selecting one of the multi-selected nodes" has been fixed.

## 19.2.56 (2021-08-17)

### Diagram

#### Bug Fixes

- `#I338244` - The issue "When drag the group node by using the arrow key the group get struck" has been fixed.

## 19.2.55 (2021-08-11)

### Diagram

#### Bug Fixes

- `#I336316` - The issue "The loaded connectors path is differ from saved connectors" has been fixed.
- `#I335836` - The Default tooltip rendered in the wrong position for the native node issue has been fixed.
- `#I337885` - The issue "Connectors have disappeared in Swim lane at initial rendering" has been fixed.

## 19.2.51 (2021-08-03)

### Diagram

#### Bug Fixes

- `#F167093` - The issue "The HTML nodes in overview takes place at the wrong position while zoom and move the HTML node in diagram "has been fixed.
- `#F166882` - The issue "Accessibility validation error in Diagram" has been fixed.
- `#F167431` - The issue "While decode the exported JPG image it has the PNG Image signature"has been fixed.

## 19.2.49 (2021-07-27)

### Diagram

#### Bug Fixes

- `#I335783` - The issue "The tooltip rendered in the wrong position when the node is placed at bottom position" has been fixed.
- `#I334315` - The issue "Update template method is triggered twice"has been fixed.

## 19.2.48 (2021-07-20)

### Diagram

#### Bug Fixes

- `#I330099` - The issue "The ports outEdges is not updated when cancel the port draw connector addition" has been fixed.
- `I324505` - The issue "An exception will raise while sending the node front to the group " has been fixed.

## 19.2.46 (2021-07-06)

### Diagram

#### Bug Fixes

- `#F166100, #F166081` - The issue "An exception occurs when resizing the diagram page with an overview" has been fixed.
- `#I333468` - The issue "The connectors cannot be grouped using group API" has been fixed.
- `#I332942` - The issue "The nodes that take place above the lane is not selectable" has been fixed.

## 19.2.44 (2021-06-30)

### Diagram

#### Bug Fixes

- `#I329576` - The issue While changing the connector flip property the connector's segment path is not updated correctly issue has been fixed.
- `#I327457` - The issue with node gradient is not applied while continuously performing the undo and redo functionality issue has been fixed.
- `#330528` - The issue "Connector horizontal Alignment is not rendered properly at initial rendering" has been fixed.
- `#328156` - The issue "An exception raised when send the swimlane back to the normal node" has been fixed.
- `#324236` - The issue "When exporting the node with gradient color the exported image does not contain proper node gradient " has been fixed.
- `#324541` - This issue "An exception occurs when printing the diagram with a Content security policy tag." has been fixed.
- `#I325640` - The issue "When dynamically adding node and perform the `bringToFront` method. The order command functionality not working properly" has been resolved.
- `#328132` - The issue "The combination of port constraints is not working" has been fixed.
- `#I327071` - the issue "When node is placed at the bottom position of the diagram component the tooltip position is rendered wrongly" issue has been fixed.
- `#I324251` - The issue "Nodes with SVG shapes have inaccurate positions in the Overview Control" has been fixed.
- `#F166050` - The issue "Context Menu not shown in iPad/android " has been fixed.
- `#I330320` - The issue "The HTML node content gets disappeared when adding the HTML node dynamically in the diagram with an overview" has been fixed.

## 19.1.69 (2021-06-15)

### Diagram

#### Bug Fixes

- `#I329576` - The issue While changing the connector flip property the connector's segment path is not updated correctly issue has been fixed.

## 19.1.67 (2021-06-08)

### Diagram

#### Bug Fixes

- `#I327457` - The issue with node gradient is not applied while continuously performing the undo and redo functionality issue has been fixed.
- `#330528` - The issue "Connector horizontal Alignment is not rendered properly at initial rendering" has been fixed.

## 19.1.66 (2021-06-01)

### Diagram

#### Bug Fixes

- `#328156` - The issue "An exception raised when send the swimlane back to the normal node" has been fixed.
- `#324236` - The issue "When exporting the node with gradient color the exported image does not contain proper node gradient " has been fixed.
- `#324541` - This issue "An exception occurs when printing the diagram with a Content security policy tag." has been fixed.
- `#I325640` - The issue "When dynamically adding node and perform the `bringToFront` method. The order command functionality not working properly" has been resolved.
- `#328132` - The issue "The combination of port constraints is not working" has been fixed.

## 19.1.65 (2021-05-25)

### Diagram

#### Bug Fixes

- `#I327071` - the issue "When node is placed at the bottom position of the diagram component the tooltip position is rendered wrongly" issue has been fixed.

## 19.1.64 (2021-05-19)

### Diagram

#### Bug Fixes

- `#I324251` - The issue "Nodes with SVG shapes have inaccurate positions in the Overview Control" has been fixed.

## 19.1.63 (2021-05-13)

### Diagram

#### Bug Fixes

- `#I322863` - This issue "Node does not drag properly when move inside swimlane" has been fixed.
- `#I326309` - This issue "While drag and move the multiple children of swimlane some children jump from one lane to another lane" has been fixed.
- `#I323817` - This issue "An exception will raise when send the native node back to the group of native nodes" has been fixed.
- `#I323457` - This issue "straight line segment not moved in group while dragging grouping node" has been fixed.
- `#I325103` - This issue "Connector alignment is not rendered properly at initial rendering" has been fixed.
- `F164350` - The issue "Annotation hyper link is not working" has been fixed.
- `#319911` - The issue "Customized style disappears when serializing the BPMN shapes" has been fixed.
- `#321939` - The issue "Swimlane send to back node working" has been fixed.
- `#322854` - The issue "Swimlane children disappear while performing the order commands" has been fixed.
- `#323203` - The issue "Exception occurs when try to redo the node's gradient color" has been fixed.
- `#324238` - The issue "An empty space will take place along with the diagram while exporting the diagram into the image" has been fixed.
- `#321284` - The issue "The loaded layout diagram is differ from the saved diagram" has been fixed.
- `F164274` - The issue "Resize functionality of the lane is not working if the can move is false" has been fixed.
- `#316688` - The issue "Symbol palette component gets rendered on every state change" has been fixed.
- `#317943` - This issue "While render the layout's nodes with the collapsed state, the nodes are not properly aligned " has been fixed.

## 19.1.59 (2021-05-04)

### Diagram

#### Bug Fixes

- `#I323457` - This issue "straight line segment not moved in group while dragging grouping node" has been fixed.
- `#I325103` - This issue "Connector alignment is not rendered properly at initial rendering" has been fixed.
- `F164350` - The issue "Annotation hyper link is not working" has been fixed.
- `#319911` - The issue "Customized style disappears when serializing the BPMN shapes" has been fixed.
- `#321939` - The issue "Swimlane send to back node working" has been fixed.
- `#322854` - The issue "Swimlane children disappear while performing the order commands" has been fixed.
- `#323203` - The issue "Exception occurs when try to redo the node's gradient color" has been fixed.
- `#324238` - The issue "An empty space will take place along with the diagram while exporting the diagram into the image" has been fixed.
- `#321284` - The issue "The loaded layout diagram is differ from the saved diagram" has been fixed.
- `F164274` - The issue "Resize functionality of the lane is not working if the can move is false" has been fixed.

## 19.1.57 (2021-04-20)

### Diagram

#### Bug Fixes

- `F164350` - The issue "Annotation hyper link is not working" has been fixed.
- `#319911` - The issue "Customized style disappears when serializing the BPMN shapes" has been fixed.
- `#321939` - The issue "Swimlane send to back node working" has been fixed.
- `#322854` - The issue "Swimlane children disappear while performing the order commands" has been fixed.
- `#323203` - The issue "Exception occurs when try to redo the node's gradient color" has been fixed.

## 19.1.56 (2021-04-13)

### Diagram

#### Bug Fixes

- `#316688` - The issue "Symbol palette component gets rendered on every state change" has been fixed.
- `317943` - This issue "While render the layout's nodes with the collapsed state, the nodes are not properly aligned " has been fixed.

## 19.1.54 (2021-03-30)

### Diagram

#### New Features

- `#285393` - Support to avoid connector overlapping with complex hierarchical layout has been added.
- `#314220` - Support for Auto scrolling feature while using drawing tool has been added.

#### Bug Fixes

- `#316429` - This issue "Nodes are not updating properly for the swim lane in the DOM during save and load" has been fixed.
- `#304194` - This issue "Straight line segments are not moved while dragging " has been fixed.
- `#309543` - This issue "overview's preview is not updated when update the diagram's size " has been fixed.
- `#311751` - This issue "when drag and drop from the palette the symbol preview not disappear " has been fixed.
- `#312744` - This issue "Exception occurs when mouse over the node with  many connector " has been fixed.
- `#301792` - This issue "Alignment of connector is misplaced in balanced layout " has been fixed.
- `#311219` - This issue "z order Commands not working for child node in group " has been fixed.
- `#312725` - This issue "Expand collapse icon cannot export properly " has been fixed.
- `#314224` - This issue "Shapes getting disappear after adding Swimlane shape " has been fixed.
- `F162436` - This issue "While set the node's isExpanded property true at initial rendering unwanted scroll is take placed" has been fixed.
- `#314664` - This issue "Exception occurs when drag and drop the node and perform undo " has been fixed.
- `F161997` - This issue "Context menu disappear while mouseover the item which has subitems " has been fixed.
- `#316472` - This issue "Strange snapping behaviors with swimlane " has been fixed.
- `#317149` - This issue "Exception occurs when drag and drop a lane on connector in swimlane " has been fixed.
- `F23048` - This issue "When change style of group at runtime the same is applied to its child too " has been fixed.
- `317728` - This issue "Line routing is not working if the connection end point of the connector has two or more nodes " has been fixed.

## 18.4.46 (2021-03-02)

### Diagram

#### Bug Fixes

- `F162436` - This issue "While set the node's isExpanded property true at initial rendering unwanted scroll is take placed" has been fixed.
- `#314664` - This issue "Exception occurs when drag and drop the node and perform undo " has been fixed.
- `F161997` - This issue "Context menu disappear while mouseover the item which has subitems " has been fixed.

#### New Features

- `#314220` - Support for Auto scrolling feature while using drawing tool has been added.

## 18.4.43 (2021-02-16)

### Diagram

#### Bug Fixes

- `#314224` - This issue "Shapes getting disappear after adding Swimlane shape " has been fixed.

## 18.4.42 (2021-02-09)

### Diagram

#### Bug Fixes

- `#312744` - This issue "Exception occurs when mouse over the node with  many connector " has been fixed.
- `#301792` - This issue "Alignment of connector is misplaced in balanced layout " has been fixed.
- `#311219` - This issue "z order Commands not working for child node in group " has been fixed.
- `#312725` - This issue "Expand collapse icon cannot export properly " has been fixed.
- `#314224` - This issue "Shapes getting disappear after adding Swimlane shape " has been fixed.

## 18.4.41 (2021-02-02)

### Diagram

#### Bug Fixes

- `#304194` - This issue "Straight line segments are not moved while dragging " has been fixed.
- `#309543` - This issue "overview's preview is not updated when update the diagram's size " has been fixed.
- `#311751` - This issue "when drag and drop from the palette the symbol preview not disappear " has been fixed.

#### New Features

- `#285393` - Support to avoid connector overlapping with complex hierarchical layout has been added.

#### Bug Fixes

## 18.4.39 (2021-01-28)

### Diagram

#### Bug Fixes

- `#308695` - This issue "Port's InEdges and outEdges are not updated properly while copy and paste " has been fixed.
- `#306529` - This issue "Node does not drop properly on swimlane " has been fixed.
- `#309041` - This issue "Nodes are not getting cleared when add new page in the diagram" has been fixed.
- `#305708` - This issue "Console error occur while save and load the diagram with swimlane nodes" has been fixed.
- `#308109` - This issue "Can't change flowshape to other basic shape" has been fixed.
- `#301792` - This issue "Child nodes are not rendered properly in Organizational chart" has been fixed.
- `#306310` - This issue "Symbol description gets rendered from middle of symbol" has been fixed.
- `#304447` - This issue "Restrict click event for nodes when zoompan tool is enabled" has been fixed.
- `#295443` - This issue "Bottom level nodes are not visible in overview" has been fixed.
- `#305992` - This issue "When drag and drop the node swimlane lane header position gets changed" has been fixed.
- `#304558` - This issue "Exception occurs when use getDiagramContent method" has been fixed.

## 18.4.35 (2021-01-19)

### Diagram

#### Bug Fixes

- `#305708` - This issue "Console error occur while save and load the diagram with swimlane nodes" has been fixed.

## 18.4.34 (2021-01-12)

### Diagram

#### Bug Fixes

- `#308695` - This issue "Port's InEdges and outEdges are not updated properly while copy and paste " has been fixed.
- `#306529` - This issue "Node does not drop properly on swimlane " has been fixed.
- `#309041` - This issue "Nodes are not getting cleared when add new page in the diagram" has been fixed.

## 18.4.32 (2020-12-29)

### Diagram

#### Bug Fixes

- `#308109` - This issue "Can't change flowshape to other basic shape" has been fixed.
- `#301792` - This issue "Child nodes are not rendered properly in Organizational chart" has been fixed.

## 18.4.31 (2020-12-22)

### Diagram

#### Bug Fixes

- `#306310` - This issue "Symbol description gets rendered from middle of symbol" has been fixed.
- `#304447` - This issue "Restrict click event for nodes when zoompan tool is enabled" has been fixed.
- `#295443` - This issue "Bottom level nodes are not visible in overview" has been fixed.
- `#305992` - This issue "When drag and drop the node swimlane lane header position gets changed" has been fixed.
- `#304558` - This issue "Exception occurs when use getDiagramContent method" has been fixed.

## 18.4.30 (2020-12-17)

### Diagram

#### New Features

- `#285393` - Line distribution functionality has been added.
- Support added to arrange the child nodes in linear way.

#### Bug Fixes

- `#304641` - This issue "Node does not gets selected on slight movement of mouse when drag constraints disabled for node " has been fixed.
- `#301443` - This issue "update annotation for BPMN node, the node position gets changed " has been fixed.
- `#301441` - This issue "BPMN Nodes dropped in wrong position " has been fixed.
- `#304047` - This issue "Exception occurs when drag and drop the SVG node into diagram " has been fixed.
- `#301792` - This issue "Child Node Rendering issue in organization chart " has been fixed.
- `#300529` - This issue "Exception occurs while change the datasource for layout at runtime" has been fixed.
- `#302274` - This issue "Mindmap layout does not render properly" has been fixed.
- `#300499` - This issue "PositionChange event does not gets triggered for completed state" has been fixed.
- `#298898` - This issue "When save and load Bpmn subprocess node not loads properly" has been fixed.
- `F158465` - This issue "Context Menu items does not gets change at run time" has been fixed.
- `#285393` - This issue "Connector Target Point connection is not connected properly in line distribution" has been fixed.
- `#297343` - This issue "While undo and redo with line routing exception occurs" has been fixed.
- `F159245` - This issue "Node z index behaves incorrectly" has been fixed.
- `#300316` - This issue "Exception occurs when try to save diagram with prevent defaults set as true" has been fixed.
- `#292439` - The issue "Exception occurs when try to draw the connector using user handle" has been fixed.

## 18.3.53 (2020-12-08)

### Diagram

#### Bug Fixes

- `#301443` - This issue "update annotation for BPMN node, the node position gets changed " has been fixed.

## 18.3.52 (2020-12-01)

### Diagram

#### Bug Fixes

- `#301441` - This issue "BPMN Nodes dropped in wrong position " has been fixed.
- `#304047` - This issue "Exception occurs when drag and drop the SVG node into diagram " has been fixed.
- `#301792` - This issue "Child Node Rendering issue in organization chart " has been fixed.
- `#300529` - This issue "Exception occurs while change the datasource for layout at runtime" has been fixed.
- `#302274` - This issue "Mindmap layout does not render properly" has been fixed.
- `#300499` - This issue "PositionChange event does not gets triggered for completed state" has been fixed.

## 18.3.51 (2020-11-24)

### Diagram

#### Bug Fixes

- `#298898` - This issue "When save and load Bpmn subprocess node not loads properly" has been fixed.
- `F158465` - This issue "Context Menu items does not gets change at run time" has been fixed.

## 18.3.50 (2020-11-17)

### Diagram

#### Bug Fixes

- `#285393` - This issue "Connector Target Point connection is not connected properly in line distribution" has been fixed.

## 18.3.48 (2020-11-11)

### Diagram

#### Bug Fixes

- `#297343` - This issue "While undo and redo with line routing exception occurs" has been fixed.
- `F159245` - This issue "Node z index behaves incorrectly" has been fixed.
- `#300316` - This issue "Exception occurs when try to save diagram with prevent defaults set as true" has been fixed.
- `#292439` - The issue "Exception occurs when try to draw the connector using user handle" has been fixed.

## 18.3.47 (2020-11-05)

### Diagram

#### New Features

- `#285393` - Line distribution functionality has been added.
- Support added to arrange the child nodes in linear way.

#### Bug Fixes

- `#297888` - This issue "Target decorator is not connected properly to the node" has been fixed.
- `#298962` - This issue "HTML template node take more time to render in Blazor" has been fixed.
- `#F159087` - This issue "When Drag and drop the node from palette exception throws" has been fixed.
- `#292439` - The issue "Exception occurs when try to draw connector on node text edit" has been fixed.
- `#294302` - The issue with "Node overlapping issue in hierarchical tree layout" has been fixed.
- `#292214` - The issue "Mouse cursor does not place on a node" has been fixed
- `#292439` - The issue "Exception occurs when try to draw connector on node text edit" has been fixed.
- `#294515` - This issue "When zoom out the diagram ruler value not update properly" has been fixed.
- `#294604` - This issue "Vertical Scroll bar appears while scroll the diagram" has been fixed.
- `#296511`, `#296304` - The issue "Nodes are not added properly to the newly added lane" has been fixed.

## 18.3.44 (2020-10-27)

### Diagram

#### Bug Fixes

- `#297888` - This issue "Target decorator is not connected properly to the node" has been fixed.
- `#298962` - This issue "HTML template node take more time to render in Blazor" has been fixed.
- `#F159087` - This issue "When Drag and drop the node from palette exception throws" has been fixed.

## 18.3.42 (2020-10-20)

### Diagram

#### Bug Fixes

- `#294515` - This issue "When zoom out the diagram ruler value not update properly" has been fixed.
- `#294604` - This issue "Vertical Scroll bar appears while scroll the diagram" has been fixed.
- `#296511`, `#296304` - The issue "Nodes are not added properly to the newly added lane" has been fixed.

## 18.3.40 (2020-10-13)

### Diagram

#### Bug Fixes

- `292439` - The issue "Exception occurs when try to draw connector on node text edit" has been fixed.
- `294302` - The issue with "Node overlapping issue in hierarchical tree layout" has been fixed.
- `292214` - The issue "Mouse cursor does not place on a node" has been fixed
- `292439` - The issue "Exception occurs when try to draw connector on node text edit" has been fixed.

## 18.3.35 (2020-10-01)

### Diagram

#### New Features

- `276871`, `F154206` - Customization support for individual symbols has been added.
- `281811` - Now the ports are rendered over the HTML layer.
- `246813` - Now supports the click event to notify the type of button clicked.
- `283317` - Fixed user handle has been added to diagram nodes and connectors.
- `F150538` - Added an Expand and Collapse palette notification event to the symbol palette.
- `277397` - Added support to notify the pan state during the scroll change event.

#### Bug Fixes

- `287578` - The issue "Connector segments not update properly" has been fixed.
- `292951` - The issue "Text size is different if Text Node is created over another diagram" has been fixed.
- `293420` - The issue "Annotation undo redo not working properly if the line routing is enabled" has been fixed.
- `289382` - The issue "Exported data returns same png format for all other format" has been fixed.
- `291513` - The issue " Exception occurs while change allowDrag from false to true for symbol palette" has been fixed.
- `292558` - The issue "Node Rotate constraints does not work properly" has been fixed.
- `289532` - The issue "Group offsetX and offsetY does not update after add child to it" has been fixed.
- `291274` - The issue "Mouse Enter, Mouse Over event does not get triggered for selected item" has been fixed.
- `F156456` - The issue "SVG image not exported properly" has been fixed
- `#288628` - The issue "HTML node does not gets added at run time" has been fixed.
- `#289513`  - The issue with "Group rotation does not work as expected" has been fixed.
- `287578` - The issue "Connector segments not update properly" has been fixed.
- `289532` - The issue "Group width and height does not update" has been fixed.
- `285600` - The issue "Complex hierarchical layout does not arrange properly" has been fixed.
- `F157055` - The issue "Port inedge and outedge not updated properly" has been fixed.
- `291364` - The issue "Connector's tooltip position updated wrongly" has been fixed.
- `287349` - The issue "Infinite loop occurs while setting delete constraints for node in swim-lane and clear diagram" has been fixed.
- `290066` - The issue "SendToBack and BringToFront not work for connector with group node" has been fixed.

## 18.2.59 (2020-09-21)

### Diagram

#### Bug Fixes

- `289382` - The issue "Exported data returns same png format for all other format" has been fixed.
- `291513` - The issue " Exception occurs while change allowDrag from false to true for symbol palette" has been fixed.
- `292558` - The issue "Node Rotate constraints does not work properly" has been fixed.
- `289532` - The issue "Group offsetX and offsetY does not update after add child to it" has been fixed.
- `291274` - The issue "Mouse Enter, Mouse Over event does not get triggered for selected item" has been fixed.

## 18.2.58 (2020-09-15)

### Diagram

#### Bug Fixes

- `291364` - The issue "Connector's tooltip position updated wrongly" has been fixed.
- `287349` - The issue "Infinite loop occurs while setting delete constraints for node in swim-lane and clear diagram" has been fixed.
- `290066` - The issue "SendToBack and BringToFront not work for connector with group node" has been fixed.

## 18.2.56 (2020-09-01)

### Diagram

#### Bug Fixes

- `287578` - The issue "Connector segments not update properly" has been fixed.
- `289532` - The issue "Group width and height does not update" has been fixed.
- `285600` - The issue "Complex hierarchical layout does not arrange properly" has been fixed.
- `F157055` - The issue "Port inedge and outedge not updated properly" has been fixed.

## 18.2.55 (2020-08-25)

### Diagram

#### Bug Fixes

- `F156456` - The issue "SVG image not exported properly" has been fixed
- `#288628` - The issue "HTML node does not gets added at run time" has been fixed.
- `#289513`  - The issue with "Group rotation does not work as expected" has been fixed.

## 18.2.54 (2020-08-18)

### Diagram

#### New Features

- `#281811` -  support to render the port over the HTML layer.

#### Bug Fixes

- `#285793`  - The issue with "Bring to front does not work for group node" has been fixed.
- `#F156309` - The issue with "Exception occurs when try to do nudge in the diagram" has been fixed.
- `#286692`  - The issue with "Node does not resize properly when created using the stack, container and text elements" has been fixed.
- `#286458` - The issue with "Node ports are gets ignored" has been fixed.
- `#286174`  - The issue with "Send to back not working after refresh the diagram using refresh() method" has been fixed.
- `#286611`  - The issue with "Size changed event does not get triggered when resizing with south, east, south east pin" has been fixed.
- `#246813`  - The issue with "To notify right/left button clicked in diagram click event" Has been fixed.
- `#286418`  - The issue with "When run the individual swimlane sample in angular 9 , throws build issue"  has been fixed.
- `#288057` - The issue with "Diagram selection do not update properly" has been fixed.

## 18.2.48 (2020-08-04)

### Diagram

#### New Features

- `#276871` -  support to add symbol description for symbols in palette.

#### Bug Fixes

- `#264082` - The issue of "Sometimes difficult to make the connection to a port when set ConnectToNearByNode constraints" has been fixed.
- `#283092` - The issue of "Exception throws when try to append a new diagram at run time In IE11" has been fixed.
- `#281759` - The issue of "SVG node do not gets visible in diagram" has been fixed.
- `#284823` - The issue of "DataLoaded event do not gets trigger after data loaded" has been fixed.
- `#285793`  - The issue with "Bring to front does not work for group node" has been fixed.

## 18.2.46 (2020-07-21)

### Diagram

#### Bug Fixes

- `#283962` - The issue of "Content of a text node is being duplicated when nowrap option is set" has been fixed.
- `#282404` - The issue of "Phase header style changes to default style after save and load diagram" has been fixed.

## 18.2.45 (2020-07-14)

### Diagram

#### Bug Fixes

- `#F155218` - The issue "DOM Exception occurs when try to change z index of group node" has been fixed.
- `#279793` - The issue of "Diagram Performance is slow in the Blazor WebAssembly app" has been fixed.
- `#281789` - The issue with "Exception occurs when try to load the diagram with line routing" has been fixed.
- `#281383` - The issue with "Exception occurs when try to add the group node in palette through addPaletteItem method" has been fixed.
- `#279047` - The issue of "Exception occurs when try to show context menu in diagram with all items as hidden" has been fixed.
- `#278621` - The issue of "When try to delete the swimlane diagram becomes unresponsive" has been fixed.
- `#278823` - The issue of "Vertical Swimlane indexes are not properly updated" has been fixed.
- `#271665` - The issue of "Exception throws when run symbol palette component in react production mode" has been fixed.
- `#279793` - The issue of "Diagram Performance is slow in the Blazor WebAssembly app" has been fixed.

## 18.2.44 (2020-07-07)

### Diagram

#### New Features

- `#259358` - Support for user handle templates has been provided.
- `#263337` - Undo and redo support has been enabled for order commands.
- `#264082` - Support provided to find nearby elements when dragging the end point of the connectors.

#### Bug Fixes

- `F153539` - The issue with "Properties are not updated in server side" has been fixed.
- `275634`  - The issue with "Exception occurs when double click on read only annotation" has been fixed.
- `273482`  - The issue with "History change event args source are mismatch for nudge commands and mouse movements" has been fixed.
- `274308`  - The issue with "Tooltip does not render when diagram placed in side bar component" has been fixed.
- `276796`  - The issue with "Exception throws when zoom in or zoom out the diagram with virtualization" has been fixed.
- `276998`  - The issue with "Provide support to cancel the drawing object when press escape key" has been fixed.
- `273484`  - Issue with state of event while the connector is being dragged is now resolved.
- `274485`  - Issue with dynamically added swimlane addInfo has been fixed.
- `264654`  - Console exception with cloning phase of swimlane is now resolved.
- `275032`  - Console exception while editing the annotation of node is resolved.
- `271060`  - The issue with "Margin does not apply for the exported image" has been fixed.
- `272898`  - The issue with "When drag some nodes in palette it does not show preview and drop in diagram" has been fixed.
- `F153185` - The issue with "Line routing does not consider for Group nodes" has been fixed.
- `#272405` - The issue with "The Double click event does not get triggered when double clicking on an annotation" has been fixed.
- `274242`  - The issue with "Strange behaviour when changing Connector source or target decorator width or height" has been fixed.
- `272497`  - The issue with "Need to consider boundary constraints when resizing the node" has been fixed.
- `272186`  - The issue on symbol description is fixed.
- `F12953` - The issue "Diagram FitToPage method not working properly by calling several times" has been fixed.
- `F13028` - The issue "Connector padding is not working for Path Node" has been fixed.
- `#275092` - The line routing for the organizational chart works now.
- `278119`  - The issue with "Exception occurs when try to export the diagram with mode data" has been fixed.
- `279145`  - The issue with "Exception occurs when try to save diagram with prevent defaults set as true" has been fixed.
- `278617`  - The issue with "Exception occurs when define two swim lanes in the diagram" has been fixed.
- `F154840` - The issue with "Exception occurs when try to load the diagram with group nodes" has been fixed.
- `279486`  - The issue with "Exception occurs when try to load the diagram with prevent defaults set as true" has been fixed.
- `F154304` - The issue with "Annotation Horizontal and vertical alignments are aligned wrongly" has been fixed.

## 18.1.55 (2020-06-02)

### Diagram

#### Bug Fixes

- `#275092` - The line routing for the organizational chart works now

## 18.1.54 (2020-05-26)

### Diagram

#### Bug Fixes

- `F153539` - The issue with "Properties are not updated in server side" has been fixed.
- `275634`  - The issue with "Exception occurs when double click on read only annotation" has been fixed.
- `273482`  - The issue with "History change event args source are mismatch for nudge commands and mouse movements" has been fixed.
- `274308`  - The issue with "Tooltip does not render when diagram placed in side bar component" has been fixed.
- `276796`  - The issue with "Exception throws when zoom in or zoom out the diagram with virtualization" has been fixed.
- `276998`  - The issue with "Provide support to cancel the drawing object when press escape key" has been fixed.

## 18.1.52 (2020-05-13)

### Diagram

#### Bug Fixes

- `273484`  - Issue with state of event while the connector is being dragged is now resolved.
- `274485`  - Issue with dynamically added swimlane addInfo has been fixed.
- `264654`  - Console exception with cloning phase of swimlane is now resolved.
- `275032`  - Console exception while editing the annotation of node is resolved.

## 18.1.48 (2020-05-05)

### Diagram

#### Bug Fixes

- `271060`  - The issue with "Margin does not apply for the exported image" has been fixed.
- `272898`  - The issue with "When drag some nodes in palette it does not show preview and drop in diagram" has been fixed.

## 18.1.46 (2020-04-28)

### Diagram

#### Bug Fixes

- `F153185` - The issue with "Line routing does not consider for Group nodes" has been fixed.
- `#272405` - The issue with "The Double click event does not get triggered when double clicking on an annotation" has been fixed.
- `274242`  - The issue with "Strange behaviour when changing Connector source or target decorator width or height" has been fixed.
- `272497`  - The issue with "Need to consider boundary constraints when resizing the node" has been fixed.
- `272186`  - The issue on symbol description is fixed.

## 18.1.45 (2020-04-21)

### Diagram

#### Bug Fixes

- `#270667` - The issue with "Prevent line routing for straight connector" has been fixed.

## 18.1.43 (2020-04-07)

### Diagram

#### Bug Fixes

- `F12953` - The issue "Diagram FitToPage method not working properly by calling several times" has been fixed.
- `F13028` - The issue "Connector padding is not working for Path Node" has been fixed.

## 18.1.42 (2020-04-01)

### Diagram

#### New Features

- `#267720`, `F152484` - Support to add annotation object in the text Edit event arguments

#### Bug Fixes

- `#266107` - The issue "Some nodes are not properly arranged in ComplexHierarchicalTree layout" has been fixed.
- `#267299` - The issue "Performance issues with scroll the layout with overview" has been fixed.
- `F152154` - The issue "Tooltip is not stay in fixed position" has been fixed.
- `F152224`, `#267708` - The issue "Some nodes dragged from the palette are not dropped properly in the diagram" has been fixed.
- `F152314`, `F152315` - The issue "Exception raised while loading a JSON data in load Diagram method" has been fixed.
- `#268272` - The issue "Not able to disable the Lane header" has been fixed.
- `#267836` - The issue "Port to Port connector docking is not proper in the Line routing" has been fixed.
- `F152279` - The issue "Swim-lane header is not proper while swapping the lane when the swimlane Node Constraints are set to None" has been fixed.
- `#269114` - The issue "Node dragging in swimlane is not working properly when line routing is enabled" has been fixed.

## 18.1.36-beta (2020-03-19)

### Diagram

#### New Features

- `#232055` - Support added to change appearance of grid pattern.

#### Bug Fixes

- `F151275` - The issue "Connector has selected wrongly when clicking the user handles of other node" has been fixed.
- `F151027` - The issue "Cannot get the TextAnnotation node margin values dropped in the swimlane" has been fixed.
- `F151264` - The issue  "Need to change evt.args node/connector type as DiagramNode/DiagramConnector in Blazor Validated" has been fixed.
- `266664` - The issue "Ruler disappears after the diagram moves beyond viewport" has been fixed.
- `F149624` - The issue "Diagram Component Export renders with black background on safari browser" has been fixed.
- `F151341` - The issue "Specifying a layout results in exception when state of nodes changes" has been fixed.
- `F151232` - The issue "Cannot read the property '0' of undefined" has been fixed.
- `#263839` - The issue "Fit To Page leaving too much space around content" has been fixed.
- `F151197` - The issue with the Zoom-Pan option that disables the connectors has been fixed.
- `#264576` - The issue "Snapping support on zooming the diagram" has been fixed.
- `#227953` - The issue "Line routing does not consider for some nodes" has been fixed.
- `F151098` - The issue "Port constraints is not working while draw connector through port" has been fixed.
- `F152070` - The exception occurs when you try to resize a node outside the boundary constraints has been fixed.
- `266374` - The issue "Tool tip does not hide while mouse move on diagram" has been fixed.
- `264862` - The Performance issue with overview sample has been fixed.
- `F151374` - The issue "Connector stroke style does not update properly" has been fixed.

## 17.4.55 (2020-03-10)

### Diagram

#### Bug Fixes

- `#227953` - The issue "Line routing does not consider for some nodes" has been fixed.
- `266374` - The issue "Tool tip does not hide while mouse move on diagram" has been fixed.
- `264862` - The Performance issue with overview sample has been fixed.
- `F151374` - The issue "Connector stroke style does not update properly" has been fixed.

## 17.4.51 (2020-02-25)

### Diagram

#### Bug Fixes

- `F151275` - The issue "Connector has selected wrongly when clicking the user handles of other node" has been fixed.
- `F151027` - The issue "Cannot get the TextAnnotation node margin values dropped in the swimlane" has been fixed.
- `F151264` - The issue  "Need to change evt.args node/connector type as DiagramNode/DiagramConnector in Blazor Validated" has been fixed.
- `266664` - The issue "Ruler disappears after the diagram moves beyond viewport" has been fixed

## 17.4.50 (2020-02-18)

### Diagram

#### Bug Fixes

- `F149624` - The issue "Diagram Component Export renders with black background on safari browser" has been fixed.
- `F151341` - The issue "Specifying a layout results in exception when state of nodes changes" has been fixed.
- `F151232` - The issue "Cannot read the property '0' of undefined" has been fixed.
- `#263839` - The issue "Fit To Page leaving too much space around content" has been fixed.
- `F151197` - The issue with the Zoom-Pan option that disables the connectors has been fixed.
- `#264576` - The issue "Snapping support on zooming the diagram" has been fixed.

## 17.4.46 (2020-01-30)

### Diagram

#### New Features

- `#232055` - Support has been provided to Clip/Ellipsis the annotation when textWrapping as WrapWithOverflow in the diagram.
- `#253884` - Template support for HTML node has been provided.
- `#236612`, `#242275` - The support has been provided to get the In and Out edges from ports.
- `#239063`, `#239214` - The support has been provided to notify key actions in command manager

#### Bug Fixes

- `#260927` - The issue "UmlClassDiagram is not updated properly in the layout" has been fixed.
- `#227953` - The exception occurred while applying line routing for the complex diagram has been fixed.
- `#259627` - The issue "Performance improvement with HTML node" has been fixed.
- `#259329` - The issue "Polyline target decorator is not aligned properly at runtime" has been fixed.
- `F149983` - The exception occurred while changing the z-index for group node at run time has been fixed.
- `259000` - The issue "ConnectionChange Event does not triggered in mouse up" has been fixed.
- `#259960` - The issue "Expand and collapse not working on the Mindmap Layout" has been fixed.
- `#260287` - The issue "left most node unable to be selected in the layout sample" has been fixed.
- `#256458` - The diagram html content is cutoff, while exporting the diagram issue has been fixed.
- `#259774` - The issue with connector and node opacity that is decreased while expanding and collapsing a ComplexHierarchicalTree layout has been fixed.
- `#259981` - Provides support to add group node children at runtime.

## 17.4.44 (2021-01-21)

### Diagram

#### Bug Fixes

- `#259960` - The issue "Expand and collapse not working on the Mindmap Layout" has been fixed.
- `#260287` - The issue "left most node unable to be selected in the layout sample" has been fixed.
- `#256458` - The diagram html content is cutoff, while exporting the diagram issue has been fixed.
- `#259774` - The issue with connector and node opacity that is decreased while expanding and collapsing a ComplexHierarchicalTree layout has been fixed.
- `#259981` - Provides support to add group node children at runtime.

## 17.4.43 (2020-01-14)

### Diagram

#### Bug Fixes

- `#259627` - The issue "Performance improvement with HTML node" has been fixed.
- `#259329` - The issue "Polyline target decorator is not aligned properly at runtime" has been fixed.
- `F149983` - The exception occurred while changing the z-index for group node at run time has been fixed.
- `259000` - The issue "ConnectionChange Event does not triggered in mouse up" has been fixed.

## 17.4.41 (2020-01-07)

### Diagram

#### New Features

- `#232055` - Support has been provided to Clip/Ellipsis the annotation when textWrapping as WrapWithOverflow in the diagram.
- `#253884` - Template support for HTML node has been provided.
- `#236612`, `#242275` - The support has been provided to get the In and Out edges from ports.

#### Bug Fixes

- `#258539` - The issue "Unable to move the connector together with the group when editing an Orthogonal connector segment in a group" has been fixed.

## 17.4.40 (2019-12-24)

### Diagram

#### Bug Fixes

- `#258522` - The issue with the connector that is not attached to the node when we draw a connector at the edge of the port has been fixed.

## 17.4.39 (2019-12-17)

### Diagram

#### New Features

- `#248460`,`#253930` - The support has been provided to restrict the movement of lane children beyond their boundaries.
- `#254732` - The support has been provided to rearrange lanes within the swimlane.

#### Bug Fixes

- `F149060` - The issue "unable to remove the connector drawn at the run time" has been fixed.
- `F148889` - The issue with the collectionChange event arguments that do not have parentId information in the element property has been fixed.
- `F148889` - The issue with the TextAnnotation element size that grows on every move has been fixed.
- `F148889` - Exception raises when we clear and change the text of TextAnnotation node and click to focus on other element has been fixed.
- `F148889` - The issue with the Position change event that is not raised properly has been fixed.
- `#227953` - The issue with updating line routing dynamically has been fixed.
- `#254993` - The issue "Text Wrapping is not working for lane headers" has been fixed.
- `#255299` - Visibility issue while using image as content for user handle is now fixed.
- `#249873` - The issue with an exception that thrown while dragging an element from the pale if we have several diagrams and destroy one diagram has been resolved.
- `#F147762` - The issue "Template annotation drawn numerous times during runtime changes" has been fixed.
- `#249484` - The issue "Multi-selected node rotation not rotating based on center" has been resolved.
- `#242645` - The issue "Unable to select a node in swimlane" has been fixed.
- `#249697` - The selection after drag and drop the nodes out side of the diagram region is now working fine.
- `#250965` - The performance issue occurs while dragging the diagram elements in flowchart samples has been resolved.
- `#F148052` - The issue "CollectionChange event support while adding lanes at runtime" has been fixed.
- `#250191` - The issue "Exception raised while deleting a node/connector when you set a diagram node/connector Id as a number" has been fixed.
- The issue "Unable to hide a layer at runtime" has been fixed.
- `#249091` - The issue with the grid lines that are black in Safari browser for Angular sample has been fixed.
- Now, the image size will be set as image node size when the size is not given.
- `#246889` - The issue "Context menu event will be triggered in ubuntu before the mouse up event, while context menu event will be fired in windows after mouse up" has been fixed.
- `#253855` - The exception that thrown in addNodeToLane method because Undo/Redo Module is not injected has been fixed.
- `#253804` - The issue with the Swimlane Header annotation styles that are unable to change has been fixed.
- `#254194` - The issue "when resizing the text node, text content does not wraps with respect to node size" has been fixed.
- `#253742` - The issue "children in the swimlane cannot be selected when resizing the lane, which is outside the view ports" has been fixed.
- `F148797`,`F148792` - The issue with the Swimlane Header annotation styles that are unable to change has been fixed.
- `#249143` - The issue "Horizontal and vertical alignment not working for the complex hierarchical layout" has been fixed.
- `#256080` - The issue with the shapes in the overview component that cannot be dragged, if the diagram ScrollLimit is Limited has been fixed.
- `#256513` - The issue "Not able to determine undo/redo action in the historyChange event" has been fixed.
- `F149553` - The issue with the position of nodes in the layout that is not retained when we interact and serialize the diagram with the layout at runtime has been fixed.

## 17.3.30 (2019-12-03)

### Diagram

#### Bug Fixes

- `#256513` - The issue "Not able to determine undo/redo action in the historyChange event" has been fixed.
- `F148889` - The issue with the collectionChange event arguments that do not have parentId information in the element property has been fixed.
- `F148889` - The issue with the TextAnnotation element size that grows on every move has been fixed.
- `F148889` - Exception raises when we clear and change the text of TextAnnotation node and click to focus on other element has been fixed.
- `F148889` - The issue with the Position change event that is not raised properly has been fixed.

## 17.3.29 (2019-11-26)

### Diagram

#### New Features

- `#248460`,`#253930` - The support has been provided to restrict the movement of lane children beyond their boundaries.
- `#254732` - The support has been provided to rearrange lanes within the swimlane.

#### Bug Fixes

- `F149060` - The issue "unable to remove the connector drawn at the run time" has been fixed.
- `#227953` - The issue with updating line routing dynamically has been fixed.
- `#254993` - The issue "Text Wrapping is not working for lane headers" has been fixed.
- `#255299` - Visibility issue while using image as content for user handle is now fixed.
- `#249873` - The issue with an exception that thrown while dragging an element from the pale if we have several diagrams and destroy one diagram has been resolved.
- `#F147762` - The issue "Template annotation drawn numerous times during runtime changes" has been fixed.
- `#249484` - The issue "Multi-selected node rotation not rotating based on center" has been resolved.
- `#242645` - The issue "Unable to select a node in swimlane" has been fixed.
- `#249697` - The selection after drag and drop the nodes out side of the diagram region is now working fine.
- `#250965` - The performance issue occurs while dragging the diagram elements in flowchart samples has been resolved.
- `#F148052` - The issue "CollectionChange event support while adding lanes at runtime" has been fixed.
- `#250191` - The issue "Exception raised while deleting a node/connector when you set a diagram node/connector Id as a number" has been fixed.
- The issue "Unable to hide a layer at runtime" has been fixed.
- `#249091` - The issue with the grid lines that are black in Safari browser for Angular sample has been fixed.
- Now, the image size will be set as image node size when the size is not given.
- `#246889` - The issue "Context menu event will be triggered in ubuntu before the mouse up event, while context menu event will be fired in windows after mouse up" has been fixed.
- `#253855` - The exception that thrown in addNodeToLane method because Undo/Redo Module is not injected has been fixed.
- `#253804` - The issue with the Swimlane Header annotation styles that are unable to change has been fixed.
- `#254194` - The issue "when resizing the text node, text content does not wraps with respect to node size" has been fixed.
- `#253742` - The issue "children in the swimlane cannot be selected when resizing the lane, which is outside the view ports" has been fixed.
- `F148797`,`F148792` - The issue with the Swimlane Header annotation styles that are unable to change has been fixed.
- `#249143` - The issue "Horizontal and vertical alignment not working for the complex hierarchical layout" has been fixed.
- `#256080` - The issue with the shapes in the overview component that cannot be dragged, if the diagram ScrollLimit is Limited has been fixed.

## 17.3.29 (2019-11-26)

### Diagram

#### New Features

- `#248460`,`#253930` - The support has been provided to restrict the movement of lane children beyond their boundaries.
- `#254732` - The support has been provided to rearrange lanes within the swimlane.

#### Bug Fixes

- `F149060` - The issue "unable to remove the connector drawn at the run time" has been fixed.
- `#227953` - The issue with updating line routing dynamically has been fixed.
- `#254993` - The issue "Text Wrapping is not working for lane headers" has been fixed.
- `#255299` - Visibility issue while using image as content for user handle is now fixed.

## 17.3.28 (2019-11-19)

### Diagram

#### Bug Fixes

- `#254194` - The issue "when resizing the text node, text content does not wraps with respect to node size" has been fixed.

- `#253742` - The issue "children in the swimlane cannot be selected when resizing the lane, which is outside the view ports" has been fixed.

- `F148797`,`F148792` - The issue with the Swimlane Header annotation styles that are unable to change has been fixed.

## 17.3.27 (2019-11-12)

### Diagram

#### Bug Fixes

- `#246889` - The issue "Context menu event will be triggered in ubuntu before the mouse up event, while context menu event will be fired in windows after mouse up" has been fixed.
- `#253855` - The exception that thrown in addNodeToLane method because Undo/Redo Module is not injected has been fixed.
- `#253804` - The issue with the Swimlane Header annotation styles that are unable to change has been fixed.

## 17.3.21 (2019-10-30)

### Diagram

#### Bug Fixes

- Now, the image size will be set as image node size when the size is not given.

### Diagram

#### Bug Fixes

- `#249091` - The issue with the grid lines that are black in Safari browser for Angular sample has been fixed.

## 17.3.19 (2019-10-22)

### Diagram

#### Bug Fixes

- `#250965` - The performance issue occurs while dragging the diagram elements in flowchart samples has been resolved.
- `#F148052` - The issue "CollectionChange event support while adding lanes at runtime" has been fixed.
- `#250191` - The issue "Exception raised while deleting a node/connector when you set a diagram node/connector Id as a number" has been fixed.
- The issue "Unable to hide a layer at runtime" has been fixed.

## 17.3.17 (2019-10-15)

### Diagram

#### New Features

- `#249143` - The issue "Horizontal and vertical alignment not working for the complex hierarchical layout" has been fixed.

#### Bug Fixes

- `#249873` - The issue with an exception that thrown while dragging an element from the pale if we have several diagrams and destroy one diagram has been resolved.
- `#F147762` - The issue "Template annotation drawn numerous times during runtime changes" has been fixed.
- `#249484` - The issue "Multi-selected node rotation not rotating based on center" has been resolved.
- `#242645` - The issue "Unable to select a node in swimlane" has been fixed.
- `#249697` - The selection after drag and drop the nodes out side of the diagram region is now working fine.

## 17.3.14 (2019-10-03)

### Diagram

#### Bug Fixes

- `#F147622` - The issue "Annotation content is not properly aligned for Bezier connector when Segments has control points" has been resolved.
- `#247074` - The issue "Overview size reset to zero while resizing the browser window" has been resolved.
- `#248460` - The node ports of all diagram nodes are visible when we move a single node in the diagram has been fixed.
- `F147492` - The issue "dragging one node and dropping it to another node, the node highlighter not removed" has been fixed.
- `#F147578`- Exception raised on swim lane rendering has been fixed.
- `#247967` - Exception raised while moving overview rectangle when HTML node contains SVG tag has been fixed.
- `#249149` - Console errors occur when try to edit the orthogonal segments using Ctrl+Shift+click is now resolved.

## 17.3.9-beta (2019-09-20)

### Diagram

#### New Features

- `211256`,`227953`,`243284` - Automatic line routing support have been added.
- `#242645` - The issue "Support to add node in lanes collection at runtime" is now resolved.

#### Bug Fixes

- `#243153` - Annotation wrapping is now working with textWrapping as WrapWithOverflow when there is a space in the annotation content.
- `#242713` - The diagram connectors is now exported properly with WebKit.
- `#247140` - The improper position of HTML node's in the overview has been fixed.
- `#F147015` - The issue on printing the diagram content alone in multiple page when margin is set as zero has been fixed.
- `#246626` - The issue "Hidden layered objects visible while changing the properties" is now resolved.
- `#245915` - Now, the z-index of the HTML nodes works properly.
- `#245696`,`#245047`,`#244836` - Now, the Angular diagram will be rendered properly when we set the target as es6/es2015 in ts.config file.
- `#244623` - The issue "Flip not working for HTML node" is now resolved.
- `#242968` - Now, the sequence connector updated properly while changing port to port connection at runtime.
- `#244365` - Now, the user handle events firing after zoom in the diagram is validated.
- `#245231` - The issue "When we draw multiple nodes horizontally and update layout at runtime, connectors are not updated in straight" is now resolved.
- `#244804` - The fill color for target Decorator is now applied properly for sequence connector.
- `#245061` - The issue "Nodes beyond the diagram view port also rendered dynamically, when enable the virtualization" is now resolved.
- `#146327` - The issue "Layout not working for Group Node" is now resolved.
- `#243648` - The issue "Exception raised while adding UML class shapes at runtime" is now resolved.
- `#146017` - The issue "Decorator is not aligned properly in palette when we set large stroke Width for it" is now resolved.
- `#242713` - The issue "Diagram Connectors not exported properly using web kit" is now resolved.
- `#244589`, `#244046` - The issue "Context menu properties are generated in MVC" is now resolved.
- `#243734` - The issue "Symbol Palette - first palette element gets removed while refresh the palette" is now resolved.
- `#244519` - The issue "Support to delete a lane from swimlane" is now resolved.
- The issue "Ports are not rendered when we enable virtualization" is now resolved.
- `#243785` - The issue "Symbol palette first row expands twice on click" is now resolved.
- `#243648` - The issue "Exception raised while adding UML class shapes at runtime" is now resolved.
- `#146017` - The issue "Decorator is not aligned properly in palette when we set large stroke width for it" is now resolved.

## 17.2.49 (2019-09-04)

### Diagram

#### Bug Fixes

- `#246626` - The issue "Hidden layered objects visible while changing the properties" is now resolved.
- `#245915` - Now, the z-index of the HTML nodes works properly.

## 17.2.46 (2019-08-22)

### Diagram

#### Bug Fixes

- `#245696`,`#245047`,`#244836` - Now, the Angular diagram will be rendered properly when we set the target as es6/es2015 in ts.config file.
- `#244623` - The issue "Flip not working for HTML node" is now resolved.
- `#242968` - Now, the sequence connector updated properly while changing port to port connection at runtime.
- `#244365` - Now, the user handle events firing after zoom in the diagram is validated.
- `#245231` - The issue "When we draw multiple nodes horizontally and update layout at runtime, connectors are not updated in straight" is now resolved.
- `#244804` - The fill color for target Decorator is now applied properly for sequence connector.
- `#245061` - The issue "Nodes beyond the diagram view port also rendered dynamically, when enable the virtualization" is now resolved.

## 17.2.41 (2019-08-14)

### Diagram

#### Bug Fixes

- `#146327` - The issue "Layout not working for Group Node" is now resolved.
- `#243648` - The issue "Exception raised while adding UML class shapes at runtime" is now resolved.
- `#146017` - The issue "Decorator is not aligned properly in palette when we set large stroke Width for it" is now resolved.
- `#242713` - The issue "Diagram Connectors not exported properly using web kit" is now resolved.
- `#244589`, `#244046` - The issue "Context menu properties are generated in MVC" is now resolved.
- `#243734` - The issue "Symbol Palette - first palette element gets removed while refresh the palette" is now resolved.
- `#244519` - The issue "Support to delete a lane from swimlane" is now resolved.
- The issue "Ports are not rendered when we enable virtualization" is now resolved.

## 17.2.40 (2019-08-06)

### Diagram

#### Bug Fixes

- `#243785` - The issue "Symbol palette first row expands twice on click" is now resolved.
- `#243648` - The issue "Exception raised while adding UML class shapes at runtime" is now resolved.
- `#146017` - The issue "Decorator is not aligned properly in palette when we set large stroke width for it" is now resolved.

## 17.2.39 (2019-07-30)

### Diagram

#### New Features

- `#242645` - The issue  "Support to add node in lanes collection at runtime" is now resolved.

#### Bug Fixes

- `#243078` - The issue "Hidden layer is visible" is now resolved.
- The issue "Context menu re-opens if you click a menu item quickly" is now working fine.

## 17.2.36 (2019-07-24)

### Diagram

#### Bug Fixes

- #236860, #237139 - The issue "MouseMove event is not triggered in Firefox" is now resolved.
- #241680 - The issue "Nodes drawn using drawing tools not appeared in overview" is now resolved.
- #240493 - The console error thrown while resizing the window in Chrome has been fixed.
- #242332 - The issue "ContextMenu not appears while clicking an empty diagram" is now resolved.

## 17.2.35 (2019-07-17)

### Diagram

#### Bug Fixes

- `#245696`,`#245047`,`#244836` - Now, the Angular diagram will be rendered properly when we set the target as es6/es2015 in ts.config file.

## 17.2.41 (2019-08-14)

### Diagram

#### Bug Fixes

- `#146327` - The issue "Layout not working for Group Node" is now resolved.
- `#243648` - The issue "Exception raised while adding UML class shapes at runtime" is now resolved.
- `#146017` - The issue "Decorator is not aligned properly in palette when we set large stroke Width for it" is now resolved.
- `#242713` - The issue "Diagram Connectors not exported properly using web kit" is now resolved.
- `#244589`, `#244046` - The issue "Context menu properties are generated in MVC" is now resolved.
- `#243734` - The issue "Symbol Palette - first palette element gets removed while refresh the palette" is now resolved.
- `#244519` - The issue "Support to delete a lane from swimlane" is now resolved.
- The issue "Ports are not rendered when we enable virtualization" is now resolved.

## 17.2.40 (2019-08-06)

### Diagram

#### Bug Fixes

- `#243785` - The issue "Symbol palette first row expands twice on click" is now resolved.
- `#243648` - The issue "Exception raised while adding UML class shapes at runtime" is now resolved.
- `#146017` - The issue "Decorator is not aligned properly in palette when we set large stroke width for it" is now resolved.

## 17.2.39 (2019-07-30)

### Diagram

#### New Features

- `#242645` - The issue  "Support to add node in lanes collection at runtime" is now resolved.

#### Bug Fixes

- `#243078` - The issue "Hidden layer is visible" is now resolved.
- The issue "Context menu re-opens if you click a menu item quickly" is now working fine.

## 17.2.36 (2019-07-24)

### Diagram

#### Bug Fixes

- #236860, #237139 - The issue "MouseMove event is not triggered in Firefox" is now resolved.
- #241680 - The issue "Nodes drawn using drawing tools not appeared in overview" is now resolved.
- #240493 - The console error thrown while resizing the window in Chrome has been fixed.
- #242332 - The issue "ContextMenu not appears while clicking an empty diagram" is now resolved.

## 17.2.35 (2019-07-17)

### Diagram

#### Bug Fixes

- #239193 - The issue "element does not placed properly when specify the position as (0,0)" is now resolved.

## 17.2.28-beta (2019-06-27)

### Diagram

#### Breaking Changes

- The `hyperLink` property in the Shape Annotation and Path annotation is renamed properly as `hyperlink`.
- The `class` property in the UML Classifier shape is renamed properly as `classShape`.
- The `interface` property in the UML Classifier shape is renamed properly as `interfaceShape`.
- The `enumeration` property in the UML Classifier shape is renamed properly as `enumerationShape`.
- The `data` property is removed from the DataSource property of the diagram.
- The `dataManager` property in the DataSource is renamed to `DataSource`.

#### New Features

- #228504 – Support has been provided to customize the tooltip of the diagram.
- #231402 – Support has been provided to show/hide segment thumb of the connector.
– An option has been added to set the icons and template in the diagram user handles.
- #232055 - Text overflow support for annotation when wrapping is enabled for annotation has been added.

#### Bug Fixes

- Z-index for nodes/connectors is now properly updated when rendering the nodes/connectors with same z-index in symbol palette and drag and drop the nodes from the symbol palette to the diagram.
- Now, the connection between the ports has been established when remove the InConnect/OutConnect from node’s constraints.
- Issue with the “Layer’s z-index property and sendLayerBackward/bringLayerForward API methods” has been fixed.
- #232371 - Drag and drop the nodes from symbol palette to the diagram will no longer work if the SymbolPalette "allowDrag" property set to false at runtime.
- Now, the connector can be moved over the connection disabled node when drawing the connector using drawing tools.
- #232226 - The issue "Annotation added multiple times in DOM if annotation's text overflow enabled and select the node" has been fixed.
- #232343 - Diagram's selectionChange event is now triggered properly when selecting another node or unselect the selected node in less than 1 second after dragging the node.
- Diagram's propertyChange event is now triggered properly when move the node using keyboard and undo/redo dragged node.
- #233008 - BPMN sequence connector does not move with stroke when its dependent node is moved issue is now fixed.
- When changing the node's path data at run time, it scales properly with respect to node's size.
- When changing the trigger type of BPMN's Task shape at run time, the trigger shape is positioned properly.
- Now, the connector's decorator is docked properly when layout is enabled and drag the node.
- When zooming the diagram, the user handles position is updated properly with respect to zoom percentage.
- If boundaryConstraints is enabled and node's rotateAngle is changed at run time, node does not exceed the boundary limit.
- When changing the annotation's properties at run time, annotation will update properly.
- #234537 - Conditional sequence connector is now working properly when connected with BPMN Service shape.
- #234307 - Undo/redo is now working properly when modifying the annotation's font size at run time.
- #234106 - When the node having different size and executing the layout, nodes are now arranged properly.
- The `hyperLink` property in the Shape Annotation and Path annotation is renamed properly as `hyperlink`.
- #234537 - The BPMN shape style is now applied to the BPMN inner elements.
- #235977 - The issue "User handles drawn multiple times while dragging a node from the palette" has been resolved.
- #235742 - The issue with the oldValue of selectionChange is shown incorrect when mouse down on node has been resolved.
- #235794 - The `textEdit` event is now fired in Edge browser.
- #236322 - The module property in the package.json has been updated.
- #237131 - The issue "Layout is messed up when diagram have disconnected nodes" has been resolved using complex hierarchical tree layout.
- #237533 - The issue "min-height and min-width properties of node does not updated properly at run time" has been resolved.
- #236866 - The issue with tooltip is shown even after deleting the node has been resolved.

## 17.1.50 (2019-06-04)

### Diagram

#### Bug Fixes

- #237131 - The issue "Layout is messed up when diagram have disconnected nodes" has been resolved using complex hierarchical tree layout.
- #237533 - The issue "min-height and min-width properties of node does not updated properly at run time" has been resolved.

## 17.1.49 (2019-05-29)

### Diagram

#### Breaking Changes

- The `data` property is removed from the DataSource property of the diagram.

## 17.1.48 (2019-05-21)

### Diagram

#### Breaking Changes

- The `class` property in the UML Classifier shape is renamed properly as `classShape`.
- The `interface` property in the UML Classifier shape is renamed properly as `interfaceShape`.
- The `enumeration` property in the UML Classifier shape is renamed properly as `enumerationShape`.

#### Bug Fixes

- #234537 - The BPMN shape style is now applied to the BPMN inner elements.
- #235977 - The issue "User handles drawn multiple times while dragging a node from the palette" has been resolved.
- #235742 - The issue with the oldValue of selectionChange is shown incorrect when mouse down on node has been resolved.
- #235794 - The `textEdit` event is now fired in Edge browser.
- #236322 - The module property in the package.json has been updated.

## 17.1.47 (2019-05-14)

### Diagram

#### Breaking Changes

- The `hyperLink` property in the Shape Annotation and Path annotation is renamed properly as `hyperlink`.

#### Bug Fixes

## 17.1.44 (2019-05-07)

### Diagram

#### Bug Fixes

- #234537 - Conditional sequence connector is now working properly when connected with BPMN Service shape.
- #234307 - Undo/redo is now working properly when modifying the annotation's font size at run time.
- #234106 - When the node having different size and executing the layout, nodes are now arranged properly.

## 17.1.43 (2019-04-30)

### Diagram

#### Bug Fixes

- When changing the node's path data at run time, it scales properly with respect to node's size.
- When changing the trigger type of BPMN's Task shape at run time, the trigger shape is positioned properly.
- Now, the connector's decorator is docked properly when layout is enabled and drag the node.
- When zooming the diagram, the user handles position is updated properly with respect to zoom percentage.
- If boundaryConstraints is enabled and node's rotateAngle is changed at run time, node does not exceed the boundary limit.
- When changing the annotation's properties at run time, annotation will update properly.

## 17.1.41 (2019-04-16)

### Diagram

- #232371 - Drag and drop the nodes from symbol palette to the diagram will no longer work if the SymbolPalette "allowDrag" property set to false at runtime.
- Now, the connector can be moved over the connection disabled node when drawing the connector using drawing tools.
- #232226 - The issue "Annotation added multiple times in DOM if annotation's text overflow enabled and select the node" has been fixed.
- #232343 - Diagram's selectionChange event is now triggered properly when selecting another node or unselect the selected node in less than 1 second after dragging the node.
- Diagram's propertyChange event is now triggered properly when move the node using keyboard and undo/redo dragged node.
- #233008 - BPMN sequence connector does not move with stroke when its dependent node is moved issue is now fixed.

## 17.1.40 (2019-04-09)

### Diagram

- Z-index for nodes/connectors is now properly updated when rendering the nodes/connectors with same z-index in symbol palette and drag and drop the nodes from the symbol palette to the diagram.
- Now, the connection between the ports has been established when remove the InConnect/OutConnect from node’s constraints.
- Issue with the “Layer’s z-index property and sendLayerBackward/bringLayerForward API methods” has been fixed.

## 17.1.38 (2019-03-29)

### Diagram

#### New Features

- Support added to create a swimlane diagram using code or a visual interface with built-in swim lane shapes.
- Support provided to prevent “previous selection gets cleared when dragging a new symbol from the symbol palette and dropping it to the diagram”.
- Support provided to cancel the drag and drop operation from the symbol palette to the diagram when the ESC key is pressed.
- Support provided to define the padding between the connector’s end point and the object to which it gets connected.
- Option has been provided to retain the selection of an object when performing undo and redo operations.
- Option provided to prevent serializing default properties when the diagram is serialized as JSON format.
- Padding option added to scroll settings.
- Now, it is possible to export HTML and native nodes to image format.
- Support provided to limit the number of actions to be stored in the history manager.

#### Bug Fixes

- The "nodes distributed incorrectly" issue has been fixed.
- The "duplicate SVG appears when node's SVG is changed" issue has been fixed.
- Drop event is now fixed when drag and drop other component is now working fine.
- Diagram does not zoom based on the center point is now working fine.
- Background color of the label and nodes will be black by default while updating dynamically is now working fine.
- Background color issue found while on text editing is not fixed.
- Connections have created from port after removing the constraints is now working fine.
- Performance issue on diagram layout has been fixed.

## 17.1.32-beta (2019-03-13)

### Diagram

#### New Features

- Support added to create a swimlane diagram using code or a visual interface with built-in swim lane shapes.
- Support provided to prevent “previous selection gets cleared when dragging a new symbol from the symbol palette and dropping it to the diagram”.
- Support provided to cancel the drag and drop operation from the symbol palette to the diagram when the ESC key is pressed.
- Support provided to define the padding between the connector’s end point and the object to which it gets connected.
- Option has been provided to retain the selection of an object when performing undo and redo operations.
- Option provided to prevent serializing default properties when the diagram is serialized as JSON format.
- Padding option added to scroll settings.
- Now, it is possible to export HTML and native nodes to image format.
- Support provided to limit the number of actions to be stored in the history manager.

#### Bug Fixes

- #236866 - The issue with tooltip is shown even after deleting the node has been resolved.

## 17.1.50 (2019-06-04)

### Diagram

#### Bug Fixes

- #237131 - The issue "Layout is messed up when diagram have disconnected nodes" has been resolved using complex hierarchical tree layout.
- #237533 - The issue "min-height and min-width properties of node does not updated properly at run time" has been resolved.

## 17.1.49 (2019-05-29)

### Diagram

#### Breaking Changes

- The `data` property is removed from the DataSource property of the diagram.

## 17.1.48 (2019-05-21)

### Diagram

#### Breaking Changes

- The `class` property in the UML Classifier shape is renamed properly as `classShape`.
- The `interface` property in the UML Classifier shape is renamed properly as `interfaceShape`.
- The `enumeration` property in the UML Classifier shape is renamed properly as `enumerationShape`.

#### Bug Fixes

- #234537 - The BPMN shape style is now applied to the BPMN inner elements.
- #235977 - The issue "User handles drawn multiple times while dragging a node from the palette" has been resolved.
- #235742 - The issue with the oldValue of selectionChange is shown incorrect when mouse down on node has been resolved.
- #235794 - The `textEdit` event is now fired in Edge browser.
- #236322 - The module property in the package.json has been updated.

## 17.1.47 (2019-05-14)

### Diagram

#### Breaking Changes

- The `hyperLink` property in the Shape Annotation and Path annotation is renamed properly as `hyperlink`.

#### Bug Fixes

## 17.1.44 (2019-05-07)

### Diagram

#### Bug Fixes

- #234537 - Conditional sequence connector is now working properly when connected with BPMN Service shape.
- #234307 - Undo/redo is now working properly when modifying the annotation's font size at run time.
- #234106 - When the node having different size and executing the layout, nodes are now arranged properly.

## 17.1.43 (2019-04-30)

### Diagram

#### Bug Fixes

- When changing the node's path data at run time, it scales properly with respect to node's size.
- When changing the trigger type of BPMN's Task shape at run time, the trigger shape is positioned properly.
- Now, the connector's decorator is docked properly when layout is enabled and drag the node.
- When zooming the diagram, the user handles position is updated properly with respect to zoom percentage.
- If boundaryConstraints is enabled and node's rotateAngle is changed at run time, node does not exceed the boundary limit.
- When changing the annotation's properties at run time, annotation will update properly.

## 17.1.41 (2019-04-16)

### Diagram

- #232371 - Drag and drop the nodes from symbol palette to the diagram will no longer work if the SymbolPalette "allowDrag" property set to false at runtime.
- Now, the connector can be moved over the connection disabled node when drawing the connector using drawing tools.
- #232226 - The issue "Annotation added multiple times in DOM if annotation's text overflow enabled and select the node" has been fixed.
- #232343 - Diagram's selectionChange event is now triggered properly when selecting another node or unselect the selected node in less than 1 second after dragging the node.
- Diagram's propertyChange event is now triggered properly when move the node using keyboard and undo/redo dragged node.
- #233008 - BPMN sequence connector does not move with stroke when its dependent node is moved issue is now fixed.

## 17.1.40 (2019-04-09)

### Diagram

- Z-index for nodes/connectors is now properly updated when rendering the nodes/connectors with same z-index in symbol palette and drag and drop the nodes from the symbol palette to the diagram.
- Now, the connection between the ports has been established when remove the InConnect/OutConnect from node’s constraints.
- Issue with the “Layer’s z-index property and sendLayerBackward/bringLayerForward API methods” has been fixed.

## 17.1.38 (2019-03-29)

### Diagram

#### New Features

- Support added to create a swimlane diagram using code or a visual interface with built-in swim lane shapes.
- Support provided to prevent “previous selection gets cleared when dragging a new symbol from the symbol palette and dropping it to the diagram”.
- Support provided to cancel the drag and drop operation from the symbol palette to the diagram when the ESC key is pressed.
- Support provided to define the padding between the connector’s end point and the object to which it gets connected.
- Option has been provided to retain the selection of an object when performing undo and redo operations.
- Option provided to prevent serializing default properties when the diagram is serialized as JSON format.
- Padding option added to scroll settings.
- Now, it is possible to export HTML and native nodes to image format.
- Support provided to limit the number of actions to be stored in the history manager.

#### Bug Fixes

- The "nodes distributed incorrectly" issue has been fixed.
- The "duplicate SVG appears when node's SVG is changed" issue has been fixed.
- Drop event is now fixed when drag and drop other component is now working fine.
- Diagram does not zoom based on the center point is now working fine.
- Background color of the label and nodes will be black by default while updating dynamically is now working fine.
- Background color issue found while on text editing is not fixed.
- Connections have created from port after removing the constraints is now working fine.
- Performance issue on diagram layout has been fixed.

## 17.1.32-beta (2019-03-13)

### Diagram

#### New Features

- Support added to create a swimlane diagram using code or a visual interface with built-in swim lane shapes.
- Support provided to prevent “previous selection gets cleared when dragging a new symbol from the symbol palette and dropping it to the diagram”.
- Support provided to cancel the drag and drop operation from the symbol palette to the diagram when the ESC key is pressed.
- Support provided to define the padding between the connector’s end point and the object to which it gets connected.
- Option has been provided to retain the selection of an object when performing undo and redo operations.
- Option provided to prevent serializing default properties when the diagram is serialized as JSON format.
- Padding option added to scroll settings.
- Now, it is possible to export HTML and native nodes to image format.
- Support provided to limit the number of actions to be stored in the history manager.

#### Bug Fixes

- Drop event is now fixed when drag and drop other component is now working fine.
- Diagram does not zoom based on the center point is now working fine.
- Background color of the label and nodes will be black by default while updating dynamically is now working fine.
- Background color issue found while on text editing is not fixed.
- Connections have created from port after removing the constraints is now working fine.
- Performance issue on diagram layout has been fixed.

## 16.4.54 (2019-02-19)

### Diagram

#### Bug Fixes

- Z-order maintained properly now when adding the nodes at runtime.
- Port dragging now working properly after rotating the nodes.
- When dragging the port, connectors associated with the ports updated properly.
- If anyone of the selected nodes doesn’t have rotate constraints, rotate handle no longer visible with the selection handles.

## 16.4.53 (2019-02-13)

### Diagram

#### New Features

- Support to flip the node/connector in both horizontal and vertical direction has been added.

## 16.4.52 (2019-02-05)

### Diagram

#### Bug Fixes

- Exception thrown while enable zoom and pan tool dynamically is now working fine.
- Exception thrown while build the diagram component with production mode is now working fine.

## 16.4.48 (2019-01-22)

### Diagram

#### Bug Fixes

- Updating data source at runtime is now working properly even if you did not define layout for a diagram.
- Now, you can modify the nodes and connectors styles at runtime.

## 16.4.47 (2019-01-16)

### Diagram

#### Bug Fixes

- Connector label position is misplaced while adding the connector in layout at run time is working fine now.

## 16.4.46 (2019-01-08)

### Diagram

#### Bug Fixes

- Performance has been improved when dragging more number of nodes and connectors.
- Issue on applying style for connector’s annotation is now fixed.

## 16.4.44 (2018-12-24)

### Diagram

#### Bug Fixes

- Alignment issue on complex hierarchical tree layout with complex data source is working fine.

## 16.4.40-beta (2018-12-10)

### Diagram

#### New Features

- Support to create a UML class diagram through code or a visual interface with the built-in class diagram shapes is added.
- Support to create a UML activity diagram through code or a visual interface with the built-in activity shapes is added.
- Support to limit the label positions while dragging a label from the connector is added.
- Support to generate a diagram by reading the data from the database, and updating the database with the newly inserted/updated/deleted nodes and connectors is added.
- Support to render a large number of nodes and connectors in a diagram for effective performance is added.
- Template support for annotation is added.

## 16.3.33 (2018-11-20)

### Diagram

#### Bug Fixes

- Exception thrown when adding the child to the Node which has multiple parent Child is now working fine.
- Textbox lost its focus when we mouse up on Diagram is now working fine.
- Issue with expand collapse, when the child having more than one parent have been fixed.
- Issue on measuring path element while refreshing the diagram is now working fine.

## 16.3.29 (2018-10-31)

### Diagram

#### Bug Fixes

- Node position is not updated properly in expand and collapse feature is now fixed.
- Diagram getting overflow when use a flex layout UI 100% width/height is now working properly.

## 16.3.27 (2018-10-23)

### Diagram

#### Bug Fixes

- Improper positioning of group offset in initial rendering is working properly.

## 16.3.25 (2018-10-15)

### Diagram

#### Bug Fixes

- Connector annotation not hide on Expand and Collapse is now working properly.
- Gridlines not disables dynamically is now working properly.

## 16.3.17 (2018-09-12)

### Diagram

#### Bug Fixes

- Data binding for Native and HTML nodes is now working properly.
- Issue with apply gradient for BPMN shapes has been fixed.
- Issue with drop event argument has been fixed.
- The image node is now rendered properly in the symbol palette.

#### New Features

- Annotation can be moved, rotated, and resized interactively.
- Group node can be added into the symbol palette.
- Poly line connector tool support has been added.
- Text annotation can be associated with BPMN nodes interactively.

## 16.2.47 (2018-08-07)

### Diagram

#### Bug Fixes

- Issue on applying gradient for BPMN shapes have fixed.
- Issue on rendering diagram in IE browser have been fixed.
- Issue on template binding for HTML and Native node have been fixed.

## 16.2.46 (2018-07-30)

### Diagram

#### Bug Fixes

- Issue on Drag event arguments have been resolved.
- Issue on changing the background image at run time has been fixed.

## 16.2.45 (2018-07-17)

### Diagram

#### Bug Fixes

- Issue on click event arguments have been resolved.

## 16.2.41 (2018-06-25)

### Diagram

The diagram component visually represents information. It is also used to create diagrams like flow charts, organizational charts, mind maps, and BPMN either through code or a visual interface.

- **Nodes** - Nodes are used to host graphical objects (path or controls) that can be arranged and manipulated on a diagram page. Many predefined standard shapes are included. Custom shapes can also be created and added easily.
- **Connectors** - The relationship between two nodes is represented using a connector.
- **Labels** - Labels are used to annotate nodes and connectors.
- **Interactive Features** - Interactive features are used to improve the run time editing experience of a diagram.
- **Data Binding** - Generates diagram with nodes and connectors based on the information provided from an external data source.
- **Commands** - Supports a set of predefined commands that helps edit the diagram using keyboard. It is also possible to configure new commands and key combinations.
- **Automatic Layout** - Automatic layouts are used to arrange nodes automatically based on a predefined layout logic. There is built-in support for organizational chart layout, hierarchical tree layout, symmetric layout, radial tree layout, and mind map layout.
- **Overview Panel** -  The overview panel is used to improve navigation experience when exploring large diagrams.
- **SymbolPalettes** - The symbol palette is a gallery of reusable symbols and nodes that can be dragged and dropped on the surface of a diagram.
- **Rulers** - The ruler provides horizontal and vertical guides for measuring diagram objects in diagram control.
- **Serialization** - When saved in JSON format a diagram’s state persists, and then it can be loaded back using serialization.
- **Exporting and Printing** - Diagrams can be exported as .png, .jpeg, .bmp, and .svg image files, and can also be printed as documents.
- **Gridlines** - Gridlines are the pattern of lines drawn behind diagram elements. It provides a visual guidance while dragging or arranging the objects on a diagram surface.
- **Page Layout** - The drawing surface can be configured to page-like appearance using page size, orientation, and margins.
- **Context Menu** - Frequently used commands can easily be mapped to the context menu.
